//---------------------------------------------------------------------------

#include <windows.h>

//---------------------------------------------------------------------------
//   Important note about DLL memory management when your DLL uses the
//   static version of the RunTime Library:
//
//   If your DLL exports any functions that pass String objects (or structs/
//   classes containing nested Strings) as parameter or function results,
//   you will need to add the library MEMMGR.LIB to both the DLL project and
//   any other projects that use the DLL.  You will also need to use MEMMGR.LIB
//   if any other projects which use the DLL will be performing new or delete
//   operations on any non-TObject-derived classes which are exported from the
//   DLL. Adding MEMMGR.LIB to your project will change the DLL and its calling
//   EXE's to use the BORLNDMM.DLL as their memory manager.  In these cases,
//   the file BORLNDMM.DLL should be deployed along with your DLL.
//
//   To avoid using BORLNDMM.DLL, pass string information using "char *" or
//   ShortString parameters.
//
//   If your DLL uses the dynamic version of the RTL, you do not need to
//   explicitly add MEMMGR.LIB as this will be done implicitly for you
//---------------------------------------------------------------------------



#pragma argsused

#include ".\Lib\api_os_version.h"

#define IDM_ZERO        100
#define IDM_TIMER       101

extern "C"
{
       __declspec(dllexport) BOOL APIENTRY Hook(HWND hWnd);
       __declspec(dllexport) void APIENTRY UnHook();
}

LRESULT CALLBACK CallBackHook(int nCode, WPARAM wParam, LPARAM lParam);
LRESULT WINAPI MINE_SubClassWndProc(HWND hwnd, UINT uMsg, WPARAM wParam, LPARAM lParam);
void  Hack(HWND hWnd);

extern HINSTANCE gHinstance = NULL;
HHOOK     gHook=NULL;
WNDPROC   pfnWndProc=NULL;
HWND      hHookWnd = NULL;
BOOL      bIsClose=FALSE;

BOOL WINAPI DllMain(HINSTANCE hinstDLL, DWORD fwdreason, LPVOID lpvReserved)
{
        switch(fwdreason)
        {
           case DLL_PROCESS_ATTACH:
              gHinstance = hinstDLL;
              DisableThreadLibraryCalls(hinstDLL);
              break;
           case  DLL_PROCESS_DETACH:
              UnHook();
              break;

        }
        return 1;
}
//---------------------------------------------------------------------------
BOOL APIENTRY Hook(HWND hWnd)
{
    UnHook();
    DWORD dwThreadID=0;
    dwThreadID = GetWindowThreadProcessId (hWnd, NULL);
    gHook = SetWindowsHookEx(WH_CALLWNDPROC , (HOOKPROC)CallBackHook, gHinstance,dwThreadID );
    if(gHook) return TRUE;
    else return FALSE;

}

void APIENTRY UnHook()
{
    if(gHook)  { UnhookWindowsHookEx(gHook); gHook = NULL; }
    if(pfnWndProc) {
        SetWindowLong( hHookWnd, GWL_WNDPROC,(LPARAM)(WNDPROC)pfnWndProc);
        pfnWndProc = NULL;
    }
}

LRESULT CALLBACK CallBackHook(int nCode, WPARAM wParam, LPARAM lParam)
{
       // Do nothing
       PCWPSTRUCT   pcwps = (PCWPSTRUCT)lParam;

       char szClass[MAX_PATH] = {0};
       GetClassName(pcwps->hwnd, szClass, MAX_PATH);
       if( stricmp(szClass, "ap") == 0  && !pfnWndProc) {
           hHookWnd = pcwps->hwnd;
           pfnWndProc = (WNDPROC)SetWindowLong( pcwps->hwnd, GWL_WNDPROC,(LPARAM)(WNDPROC)MINE_SubClassWndProc);

           // NmJ ap{
           HMENU hMenuPopup = CreateMenu ();
           AppendMenu (hMenuPopup, MF_STRING, IDM_ZERO,   "{s(&Z)");
           AppendMenu (hMenuPopup, MF_STRING, IDM_TIMER,  "p(&S)");

           HMENU hMenu = GetMenu( hHookWnd );
           HMENU hSubMenu = GetSubMenu(hMenu,0);
           InsertMenu(hSubMenu, 1,  MF_BYPOSITION | MF_POPUP,(UINT)hMenuPopup,"(&P)");
       }

       return CallNextHookEx(gHook, nCode, wParam, lParam);
}

LRESULT WINAPI MINE_SubClassWndProc(HWND hwnd, UINT uMsg, WPARAM wParam, LPARAM lParam)
{
    switch(uMsg)
    {
       case WM_COMMAND:
           switch(wParam)
           {
              case IDM_ZERO:
              {
                // }ҦϰAïdĤ@欰}
                Hack(hwnd);
                break;
              }
              case IDM_TIMER:
                DWORD dwFlag = GetMenuState(GetSubMenu(GetMenu(hwnd),0),wParam,MF_BYCOMMAND) & MF_CHECKED;
                if( dwFlag != MF_CHECKED) {
                     KillTimer(hwnd,1);
                     CheckMenuItem(GetSubMenu(GetMenu(hwnd),0),wParam ,MF_CHECKED);
                }
                else {
                     SetTimer(hwnd,1,1000,(TIMERPROC )NULL);
                     CheckMenuItem(GetSubMenu(GetMenu(hwnd),0),wParam ,MF_UNCHECKED);
                }

                break;
           }
           break;
      case WM_TIMER:
       {
           CheckMenuItem(GetSubMenu(GetMenu(hwnd),0),IDM_TIMER ,MF_UNCHECKED);
           break;
       }

       case WM_NCDESTROY:
       {
           LRESULT lRet = CallWindowProc((FARPROC)pfnWndProc, hwnd, uMsg, wParam, lParam);
           if(pfnWndProc) {
                SetWindowLong( hHookWnd, GWL_WNDPROC,(LPARAM)(WNDPROC)pfnWndProc);
                pfnWndProc = NULL;
           }
           SendMessage(FindWindow(NULL,"MINE Plus"), WM_CLOSE, 0L, 0L);

           return lRet;
        }

    }

    return CallWindowProc((FARPROC)pfnWndProc, hwnd, uMsg, wParam, lParam);
}

void  Hack(HWND hWnd)
{
    BYTE *MINE;
    DWORD dwTimer;
    DWORD dwOpenedCount;
    DWORD dwWidth;
    DWORD dwHeight;
    DWORD dwClearCount;
    DWORD dwBombOver;
    DWORD dwBombCount;
    DWORD dwBaseAddress;

    DWORD ProcessId;
    HANDLE hProcess;
    OSVersion osver;

    //HANDLE hWnd = FindWindow(NULL,"ap");
    GetWindowThreadProcessId(hWnd,&ProcessId);
    hProcess=OpenProcess(PROCESS_ALL_ACCESS,FALSE,ProcessId);


    switch( osver.OS_TypeID )
    {
       case OS_XP_Professional:
       case OS_XP_Home:
            MINE = new BYTE[848];
            ReadProcessMemory(hProcess,(void*)0x01005194 ,&dwBombOver,sizeof(DWORD),NULL);
            dwBaseAddress = 0x01005330;
            ReadProcessMemory(hProcess,(void*)dwBaseAddress ,&dwBombCount,sizeof(DWORD),NULL);
            dwBaseAddress+=sizeof(DWORD);
            ReadProcessMemory(hProcess,(void*)dwBaseAddress ,&dwWidth,sizeof(DWORD),NULL);
            dwBaseAddress+=sizeof(DWORD);
            ReadProcessMemory(hProcess,(void*)dwBaseAddress ,&dwHeight,sizeof(DWORD),NULL);
            dwBaseAddress+=sizeof(DWORD)*2;
            ReadProcessMemory(hProcess,(void*)dwBaseAddress ,MINE,848,NULL);
            dwBaseAddress=0x0100579C;
            ReadProcessMemory(hProcess,(void*)dwBaseAddress ,&dwTimer,sizeof(DWORD),NULL);
            dwBaseAddress+=sizeof(DWORD);
            ReadProcessMemory(hProcess,(void*)dwBaseAddress ,&dwClearCount,sizeof(DWORD),NULL);
            dwBaseAddress+=sizeof(DWORD);
            ReadProcessMemory(hProcess,(void*)dwBaseAddress ,&dwOpenedCount,sizeof(DWORD),NULL);
            break;

       case OS_Win2000_Server:
       case OS_Win2000_Advanced:
       case OS_Win2000_Workstation:
            MINE = new BYTE[864];
            dwBaseAddress = 0x010056F0;

            ReadProcessMemory(hProcess,(void*)dwBaseAddress ,&dwTimer,sizeof(DWORD),NULL);
            dwBaseAddress+=sizeof(DWORD);
            ReadProcessMemory(hProcess,(void*)dwBaseAddress ,&dwOpenedCount,sizeof(DWORD),NULL);
            dwBaseAddress+=sizeof(DWORD);
            ReadProcessMemory(hProcess,(void*)dwBaseAddress ,&dwWidth,sizeof(DWORD),NULL);
            dwBaseAddress+=sizeof(DWORD);
            ReadProcessMemory(hProcess,(void*)dwBaseAddress ,&dwClearCount,sizeof(DWORD),NULL);
            dwBaseAddress+=sizeof(DWORD);
            ReadProcessMemory(hProcess,(void*)dwBaseAddress ,MINE,864,NULL);
            dwBaseAddress+=864;
            ReadProcessMemory(hProcess,(void*)dwBaseAddress ,&dwBombOver,sizeof(DWORD),NULL);
            dwBaseAddress+=sizeof(DWORD);
            ReadProcessMemory(hProcess,(void*)dwBaseAddress ,&dwOpenedCount,sizeof(DWORD),NULL);
            dwBaseAddress+=sizeof(DWORD);
            ReadProcessMemory(hProcess,(void*)dwBaseAddress ,&dwHeight,sizeof(DWORD),NULL);
            dwBaseAddress+=sizeof(DWORD);
            ReadProcessMemory(hProcess,(void*)dwBaseAddress ,&dwBombCount,sizeof(DWORD),NULL);
            break;
    }


    char *pMine=(char*)MINE;

    //  Ʀrϥ 0x01 ~ 0x09    Xlϥ 0x0E  }ϥ  0x0F  apϥ 0x0A  eapϥ 0x0B
    // v}apϥ 0xCC    ݸϥ  0x0D
    //  ap 0x80  Ʀr 0x40
    for(DWORD i=1;i<=dwHeight;i++)
      for(DWORD j=1;j<=dwWidth;j++)
      {
          unsigned char v = (char)pMine[i*32+j];

          if(i==1 && j ==1) {
              // pGĤ@欰apAmwϰ
              if((v & 0xF0) == 0x80) {
                 BOOL IsSwitch=FALSE;
                 pMine[i*32+j] = 0x0F;
                 // ̧ǴMwϡAñN쪺wϸmap
                 for(DWORD l=i;l<=dwHeight;l++) {
                    for(DWORD r=j+1;r<dwWidth;r++) {
                        if( ((char)pMine[l*32+r] & 0xF0) == 0x00) {
                             pMine[l*32+r] = 0x8F;
                             IsSwitch=TRUE;
                             break;
                        }
                   }
                   if(IsSwitch) break;
                 }
              }
              else  // Ĥ@wQ}AN]}w
                 pMine[i*32+j] = 0x0F;
              v=pMine[i*32+j];
              continue;
          }
          switch((v & 0xF0))
          {
             case 0x00:  // wϰ
                // wNI] Lap
                pMine[i*32+j] = 0x40; 
                // p⦹IEx apƶq
                for(int l=-1;l<2;l++)
                   for(int r=-1;r<2;r++) {
                      v = (char)MINE[i*32+j+l*32+r];
                      if( (v & 0x80))
                         pMine[i*32+j]++;
                   }
                break;


             case 0x40:  // }Ұϰ
                break;

             case 0x80:  // apϰ
                // NIаOXl
                if( (v & 0x0F) == 0x0F )
                    pMine[i*32+j] = 0x8E;

                break;

             default:
                break;


          }
    }

    switch( osver.OS_TypeID )
    {
       case OS_XP_Professional:
       case OS_XP_Home:
            dwBombOver = 0;   // NѾlapƳ] 0
            WriteProcessMemory(hProcess,(void*)0x01005194 ,&dwBombOver,sizeof(DWORD),NULL);
            dwBaseAddress = 0x01005330;
            //WriteProcessMemory(hProcess,(void*)dwBaseAddress ,&dwBombCount,sizeof(DWORD),NULL);
            dwBaseAddress+=sizeof(DWORD);
            //WriteProcessMemory(hProcess,(void*)dwBaseAddress ,&dwWidth,sizeof(DWORD),NULL);
            dwBaseAddress+=sizeof(DWORD);
            //WriteProcessMemory(hProcess,(void*)dwBaseAddress ,&dwHeight,sizeof(DWORD),NULL);
            dwBaseAddress+=sizeof(DWORD)*2;
            WriteProcessMemory(hProcess,(void*)dwBaseAddress ,MINE,848,NULL);
            dwBaseAddress=0x0100579C;
            //WriteProcessMemory(hProcess,(void*)dwBaseAddress ,&dwTimer,sizeof(DWORD),NULL);
            dwBaseAddress+=sizeof(DWORD);
            //WriteProcessMemory(hProcess,(void*)dwBaseAddress ,&dwClearCount,sizeof(DWORD),NULL);
            dwBaseAddress+=sizeof(DWORD);
            dwOpenedCount = dwClearCount-1;   // Nݶ}Ҫƶq] 1
            WriteProcessMemory(hProcess,(void*)dwBaseAddress ,&dwOpenedCount,sizeof(DWORD),NULL);
            break;
       case OS_Win2000_Server:
       case OS_Win2000_Advanced:
       case OS_Win2000_Workstation:
            dwBaseAddress = 0x010056F0;
            //WriteProcessMemory(hProcess,(void*)dwBaseAddress ,&dwTimer,sizeof(DWORD),NULL);
            dwBaseAddress+=sizeof(DWORD);
            dwOpenedCount = dwClearCount-1;
            WriteProcessMemory(hProcess,(void*)dwBaseAddress ,&dwOpenedCount,sizeof(DWORD),NULL);
            dwBaseAddress+=sizeof(DWORD);
            //WriteProcessMemory(hProcess,(void*)dwBaseAddress ,&dwWidth,sizeof(DWORD),NULL);
            dwBaseAddress+=sizeof(DWORD);
            //WriteProcessMemory(hProcess,(void*)dwBaseAddress ,&dwClearCount,sizeof(DWORD),NULL);
            dwBaseAddress+=sizeof(DWORD);
            WriteProcessMemory(hProcess,(void*)dwBaseAddress ,MINE,864,NULL);
            dwBaseAddress+=864;
            dwBombOver = 0;
            WriteProcessMemory(hProcess,(void*)dwBaseAddress ,&dwBombOver,sizeof(DWORD),NULL);
            dwBaseAddress+=sizeof(DWORD);
            //WriteProcessMemory(hProcess,(void*)dwBaseAddress ,&dwOpenedCount,sizeof(DWORD),NULL);
            //dwBaseAddress+=sizeof(DWORD);
            //WriteProcessMemory(hProcess,(void*)dwBaseAddress ,&dwHeight,sizeof(DWORD),NULL);
            //dwBaseAddress+=sizeof(DWORD);
            //WriteProcessMemory(hProcess,(void*)dwBaseAddress ,&dwBombCount,sizeof(DWORD),NULL);
            break;
    }

    CloseHandle(hProcess);
    delete [] MINE;
    ShowWindow(hWnd, SW_HIDE);
    ShowWindow(hWnd, SW_SHOW);
}
